(* よーしパパインライン展開しちゃうぞー *)

open Global
open ILang

let threshold_min = 3 (* サイズがこれ以下の関数はインライン化 *)
let threshold = ref threshold_min
let envl = ref M2.empty

let rec is_rec x e =
  match e with
  | V _ -> false
  | Op(y,_) -> x = y
  | If(_,_,_,e1,e2) | Let(_,e1,e2) -> is_rec x e1 || is_rec x e2
  | LetRec(_,_,_,e) -> is_rec x e

let rec g div env e =
  match e with
  | Op(Label x, ys) when M2.mem x !envl ->
      let (s, zs, body) = M2.find x !envl in
      if s <= max threshold_min (!threshold / div)
      then Alpha.g (M.add_list2 zs ys M.empty) body
      else e
  | Op(Var x, ys) when M.mem x env ->
      let (s, zs, body) = M.find x env in
      if s <= max threshold_min (!threshold / div)
      then Alpha.g (M.add_list2 zs ys M.empty) body
      else e
  | Let(x,e1,e2) -> Let(x, g div env e1, g div env e2)
  | LetRec(x,ys,e1,e2) ->
      let env_ =
        if is_rec (Var x) e1 then env
        else M.add x (size e1, ys, e1) env
      in
      LetRec(x, ys, g 1 env_ e1, g div env_ e2)
  | If(c,x,y,e1,e2) -> If(c,x,y, g (div*2) env e1, g (div*2) env e2)
  | V _ | Op _ -> e

let f e =
  let sfs = List.rev_map (fun x -> size x.body, x) !gl_funs in
  let sfs = List.fast_sort (fun x y -> fst x - fst y) sfs in
  gl_funs := List.map snd sfs;
  envl := List.fold_left
      (fun m { name = x; args = ys; body = e } ->
        if is_rec (Label x) e then m
        else M2.add x (size e, ys, e) m)
      M2.empty !gl_funs;
  gl_funs := List.map
      (fun x -> { x with body = g 1 M.empty x.body })
      !gl_funs;
  g 1 M.empty e
