(* compiler.top œeXgƂp *)
let test0 str = Parser.main Lexer.token (Lexing.from_string str)
let test1 x = Concat.f x
let test2 x = ToFlatSyntax.f (test1 x)
let test3 x = Typing.f (test2 x)
let test4 x = Expansion.f (test3 x)
let test5 x = ToILang.f (test4 x)
let test6 x = Englobal.f (test5 x)
let test7 x = Closure.f (test6 x)

let opt1 i x = Opt1.f i (test5 x)
let opt2 i x = Opt2.f i (Closure.f (Englobal.f (opt1 i x)))

let test8 x = ToTreeAsm.f (opt2 1000 x)
let test9 x = Opt3.f (test8 x)
let test10 x = RegAlloc.f (test9 x)
let test11 x = StkAlloc.f (test10 x)
let test12 x = ToLinearAsm.f (test11 x)
let test13 x = Peephole.f (test12 x)
let test14 x = Emit.f stdout (test13 x)

let rec pp e =
  match e with
  | FlatSyntax.LetRec(x,ys,e1,e2) ->
      if List.mem x Builtin.fun_idents then pp e2
      else FlatSyntax.LetRec(x,ys,e1,pp e2)
  | _ -> e

let hash_elements h = Hashtbl.fold (fun k v l -> (k,v)::l) h []

let file x =
  let ic = open_in x in
  let a = Parser.main Lexer.token (Lexing.from_channel ic) in
  close_in ic; a
